#!/usr/bin/python

import threading
import time

class myThread (threading.Thread):
    def __init__(self, name):
        threading.Thread.__init__(self)
        self.name = name
    def run(self):
        print "Starting " + self.name
        # Get the lock
        threadLock.acquire()
        printMessage(self.name)
        print "Quitting " + self.name
        # Release the lock
        threadLock.release()

def printMessage(threadName):
    for x in range(0, 10):
        print "Hello from " + threadName + ": " + str(x)
        time.sleep(1)

threadLock = threading.Lock()
threads = []

# Create new threads
thread1 = myThread("thread 1")
thread2 = myThread("thread 2")
thread3 = myThread("thread 3")
thread4 = myThread("thread 4")

# Start the four Threads
thread1.start()
thread2.start()
thread3.start()
thread4.start()

# Add threads to thread list
threads.append(thread1)
threads.append(thread2)
threads.append(thread3)
threads.append(thread4)

# Wait for all threads to finish
for t in threads:
    t.join()

print "Program finished!"
